<!-- IGAC proyecto SNC
@author david.cifuentes 
@description - Página que muestra la documentación de un trámite 
    y la opción de solicitar documentos (en asignación)
-->

<h:form xmlns="http://www.w3.org/1999/xhtml"
        xmlns:ui="http://java.sun.com/jsf/facelets"
        xmlns:f="http://java.sun.com/jsf/core"
        xmlns:h="http://java.sun.com/jsf/html"
        xmlns:fn="http://java.sun.com/jsp/jstl/functions"
        xmlns:p="http://primefaces.org/ui"
        id="solicitarDocumentacionForm" onkeypress="return event.keyCode != 13;">

    <h:panelGrid columns="1" cellspacing="0">

        <h:panelGrid width="1030">
            <ui:include src="tablaDocumentosAsociados.xhtml">
                <ui:param name="selectedTramiteParam"
                          value="#{selectedTramiteParam}" />
                <ui:param name="currentManagedBeanParam"
                          value="#{managedBeanParam}" />
            </ui:include>
        </h:panelGrid>

        <p:spacer height="20" width="0" />
        <h:panelGrid id="documentosPorSolicitarPanel"
                     rendered="#{managedBeanParam.verSolicitudDocsBool}" width="80%">

            <p:fieldset>

                <legend> <h:outputLabel value="Documentos por solicitar"
                                        styleClass="legendTitle" /> </legend>


                <h:panelGrid columns="3" cellspacing="2" width="1000">
                    <h:panelGrid columns="2">
                        <h:outputLabel value="Tipo de documento:"
                                       styleClass="outputLabelStyle" />
                        <h:outputLabel value="*" styleClass="requiredLabelStyle" />
                    </h:panelGrid>
                    <h:selectOneMenu id="tipoDocumento" label="Tipo de documento"
                                     style="width:850px;"
                                     value="#{managedBeanParam.tipoDocumentoAdicional}" required="true">
                        <f:selectItems
                            value="#{managedBeanParam.itemListTiposDeDocumento}" />
                        <f:converter converterId="tipoDocumentoConverter" />
                    </h:selectOneMenu>
                    <p:message for="tipoDocumento" display="icon" id="tipoDocumentoMsg" />

                    <h:outputLabel value="Detalle: " styleClass="outputLabelStyle" />
                    <h:inputText id="detalle" style="width:550px;"
                                 value="#{managedBeanParam.detalleDocumentoAdicional}" size="95"
                                 label="Detalle" maxlength="1000" />
                </h:panelGrid>

                <h:panelGrid columns="2" cellspacing="5">
                    <p:commandButton value="Adicionar" icon="ui-icon-plus"
                                     action="#{managedBeanParam.adicionarDocumentoALaSolicitud}"
                                     update="documentosPorSolicitarPanel"/>
                </h:panelGrid>


                <h:panelGrid columns="1" cellspacing="5" width="100%"
                             id="panelTablaDocumentosPorSolicitar">

                    <p:messages id="msgDoc" showDetail="false" globalOnly="false" />					

                    <p:dataTable id="tablaDocumentosPorSolicitar"
                                 var="documentosPorSolicitar"
                                 value="#{managedBeanParam.documentosPorSolicitar}"
                                 selectionMode="multiple" editable="true"
                                 selection="#{managedBeanParam.selectedDocumentosPorSolicitar}"
                                 rowKey="#{documentosPorSolicitar.tipoDocumento}"
                                 emptyMessage="No existen documentos solicitados">

                        <p:ajax event="rowSelect" 
                                update=":solicitarDocumentacionForm:eliminarBtn, :solicitarDocumentacionForm:aceptarBtn" />
                        <p:ajax event="rowUnselect" 
                                update=":solicitarDocumentacionForm:eliminarBtn, :solicitarDocumentacionForm:aceptarBtn" />
                        <p:ajax event="rowEdit" 
                                update=":solicitarDocumentacionForm:eliminarBtn, :solicitarDocumentacionForm:aceptarBtn" />

                        <p:column headerText="Opciones" style="width:50px">
                            <p:rowEditor />
                        </p:column>

                        <p:column sortBy="#{documentosPorSolicitar.tipoDocumento.nombre}">
                            <f:facet name="header">
                                Tipo de documento
                            </f:facet>
                            <h:outputText
                                value="#{documentosPorSolicitar.tipoDocumento.nombre}" />
                        </p:column>


                        <p:column headerText="Detalle" style="width:125px">
                            <p:cellEditor>
                                <f:facet name="output">
                                    <h:outputText value="#{documentosPorSolicitar.detalle}" />
                                </f:facet>
                                <f:facet name="input">
                                    <h:inputText value="#{documentosPorSolicitar.detalle}"
                                                 maxlength="1000" />
                                </f:facet>
                            </p:cellEditor>
                        </p:column>

                        <p:column sortBy="#{documentosPorSolicitar.fechaSolicitudDocumento}">
                            <f:facet name="header">
                                Fecha de solicitud
                            </f:facet>
                            <h:outputText
                                value="#{documentosPorSolicitar.fechaSolicitudDocumento}" >
                                <f:convertDateTime
                                    pattern="#{general.formatoFechaComponenteCalendar}" />
                            </h:outputText>
                        </p:column>

                    </p:dataTable>
                    <h:panelGrid columns="2" >
                        <p:commandButton value="Eliminar" id="eliminarBtn"
                                         widgetVar="eliminarBtn" icon="ui-icon-trash"
                                         update="panelTablaDocumentosPorSolicitar, msgDoc"
                                         process="@this, panelTablaDocumentosPorSolicitar"
                                         action="#{managedBeanParam.eliminarDocumentoDeLaSolicitud}" ajax="true" />
                    </h:panelGrid>

                    <h:panelGrid id="panelEnvioEmail" columns="2">

                        <h:outputLabel value="Enviar solicitud por correo electrónico: "
                                       styleClass="outputLabelStyle" />
                        <h:selectOneRadio value="#{managedBeanParam.emailBool}"
                                          layout="pageDirection" immediate="true" 
                                          disabled="#{empty managedBeanParam.solicitantesEmail}">
                            <f:selectItem itemLabel="SI" itemValue="true" />
                            <f:selectItem itemLabel="NO" itemValue="false" />
                            <p:ajax update="solicitarDocumentacionForm" />
                        </h:selectOneRadio>
                    </h:panelGrid>

                    <h:panelGrid id="panelEmail" columns="2"
                                 rendered="#{managedBeanParam.emailBool}">

                        <p:dataTable id="tablaEmailSolicitantes"
                                     value="#{managedBeanParam.solicitantesEmail}"
                                     emptyMessage="Los solicitantes registrados no tienen e-mail"
                                     var="solicitanteEmail">
                            <p:column headerText="Solicitantes con correo electrónico">
                                <h:outputText value="#{solicitanteEmail.nombreCompleto}" />
                            </p:column>
                            <p:column headerText="Correo electrónico">
                                <h:outputText value="#{solicitanteEmail.correoElectronico}" />
                            </p:column>
                        </p:dataTable>
                    </h:panelGrid>

                    <h:panelGrid id="panelBtn" columns="3" cellspacing="10">
                        <p:spacer width="500" height="0" />
                        <p:commandButton value="Aceptar" id="aceptarBtn"
                                         process="@this, panelBtn" icon="ui-icon-check"
                                         disabled="#{fn:length(managedBeanParam.documentosPorSolicitar) eq 0}"
                                         update="documentosPorSolicitarPanel, :asignacionOficioForm"
                                         onclick="statusDialog2.show();"
                                         onsuccess="statusDialog2.hide();asignacionOficioWV.show();"
                                         oncomplete="solicitarDocumentacionWV.hide();"
                                         action="#{managedBeanParam.guardarDocumentosSolicitados}">
                            <f:setPropertyActionListener value="false"
                                                         target="#{tramiteASolicitarDocumentos.vistaReporteDespuesDeRadicar}" />
                        </p:commandButton>
                        <p:commandButton value="Cerrar" title="Cierra esta ventana"
                                         process="@this, panelBtn"
                                         action="#{managedBeanParam.cerrarSolicitarDocumentacion}"
                                         oncomplete="solicitarDocumentacionWV.hide()" icon="ui-icon-close" />
                    </h:panelGrid>
                </h:panelGrid>
            </p:fieldset>

        </h:panelGrid>
    </h:panelGrid>
</h:form>